Subtle bug in PartModuleList this[string className]
04/23/2014 08:11 AM - swamp_ig
Description

public PartModule this[string className]
{
get
{
// Change this variable to whatever your private variable is obfiscated from
List<PartModule> theList = null;
int hashCode = className.GetHashCode () ;
for (int i1 = 0; i < thelList.Count; i++)
{
PartModule partModule = thelList[i];
// DANGER! never compare hash codes without also comparing equality.
// you can get strings that hash to the same value.
// Besides, native string comparison does this already so there's really no perfor
mance gain
if (partModule.ClassName == className)
return partModule;

// This isn't your error, but you get the idea.
Debug.LogError ("Unable to get class " + className + " from PartModuleList");
return null

History

#1 - 04/23/2014 08:12 AM - swamp_ig

Note: the 7th line is superfluous obviously.

#2 - 04/26/2014 05:11 PM - swamp_ig

What might also be a good option would be to change PartModuleList so it extends System.Collections.ObjectModel.KeyedCollection<string,
PartModuleList>

That way you're extending an API class which you know works.

There's a few places where you are using a string hash-code in the place of an actual string. This really isn't a good idea and will result in subtle, hard
to detect bugs.

It's probably actually going to be slower than native string comparison too. The compiler collects all strings that are defined statically into the same

object, and you can call string.Intern on any strings defined dynamically to internalize them in the same way. That way comparison is done on object
identity, so it's very quick.

#3 - 07/17/2016 09:25 AM - TriggerAu

- Status changed from New to Needs Clarification

#4 - 08/09/2016 10:39 AM - TriggerAu

- Status changed from Needs Clarification to Closed
- % Done changed from 0 to 100

Closing this report out for now. If you find it is still occuring in the latest version of KSP please open a new report (and this one can be linked to it.) For
best results, the wiki contains really useful info for when creating a report http:/bugs.kerbalspaceprogram.com/projects/ksp/wiki.

You can also ask questions about the bug cleanup in the forum here:
http://forum.kerbalspaceprogram.com/index.php?/topic/143980-time-to-clean-up-the-bug-tracker/ and tag @TriggerAu to get my attention
